﻿add-pssnapin vmware.vimautomation.core
##add-pssnapin vmware.vimautomation.vds - Add this snapin if using PowerCLI 5.5 or lower. 
start-sleep -s 3

start-transcript -path C:\temp\ESXI_Host_Configs_10NIC_ISCSI\ESXI_Host_Config_Log.txt
$Servers = import-csv C:\temp\ESXI_Host_Configs_10NIC_ISCSI\ESXI_Host_Configs_10NIC_ISCSI.csv

$S = 0

foreach($Server in $Servers)
{
    connect-viserver -server $Server.HostIP -protocol https -user root -password $Server.HostPassword
    $esxcli = get-esxcli
    $HostNet = get-vmhostnetwork
    $Host1 = Get-VMHost
    set-vmhostnetwork -Network $HostNet -Hostname $Server.Hostname -DomainName $Server.DomainName -SearchDomain $Server.DomainName

    # Set NTP Server on Hosts
    add-vmhostntpserver -ntpserver $Server.NTP
    get-vmhostservice | where {$_.Key -eq "ntpd" } | Start-VMHostService
    get-vmhostservice | where {$_.Key -eq "ntpd" } | Set-VMHostService -Policy "Automatic"

    # Set DNS Servers on Hosts
    Set-VMHostNetwork -Network $HostNet -DnsAddress $Server.DnsIP,$Server.DNSIP2

    ## Turn on ESXI SHELL and SSH Access

    get-vmhostservice | where {$_.Key -eq "TSM-SSH" } | set-vmhostservice -policy "Automatic"
    get-vmhostservice | where {$_.Key -eq "TSM-SSH" } | start-vmhostservice
    get-vmhostservice | where {$_.Key -eq "TSM" } | set-vmhostservice -policy "Automatic"
    get-vmhostservice | where {$_.Key -eq "TSM" } | start-vmhostservice

    # Build ISCSI vSwitches
    if($Server.MultiSubNetISCSI -eq "Yes")
    {

    New-VirtualSwitch -VMHost $Host1 -Name "ISCSI 1" -Mtu 9000
    New-VirtualSwitch -VMHost $Host1 -Name "ISCSI 2" -Mtu 9000
    $iVSwitch1 = get-virtualswitch -vmhost $Host1 -Name "ISCSI 1"
    $iVSwitch2 = get-virtualswitch -vmhost $Host1 -Name "ISCSI 2"

    New-VMHostNetworkAdapter -VMHost $Host1 -PortGroup iscsi1 -VirtualSwitch $iVSwitch1 -MTU 9000
    New-VMHostNetworkAdapter -VMHost $Host1 -PortGroup iscsi2 -VirtualSwitch $iVSwitch2 -MTU 9000
   

    # Adds Physical Adapters to ISCSI vSwitches.

    $PHYSISCSI1 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyISCSINIC1
    $iVSwitch1 | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYSISCSI1 -Confirm:$false

    $PHYSISCSI2 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyISCSINIC2
    $iVSwitch2 | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYSISCSI2 -Confirm:$false

    # Sets IP Address of ISCSI VMKERNAL PORTS

    $ISCSI1 = get-vmhostnetworkadapter | where { $_.portgroupname -eq "iscsi1" }
    set-vmhostnetworkadapter -virtualnic $ISCSI1 -ip $Server.ISCSI1 -SubnetMask $Server.iscsisubmask -Confirm:$false

    $ISCSI2 = get-vmhostnetworkadapter | where { $_.portgroupname -eq "iscsi2" }
    set-vmhostnetworkadapter -virtualnic $ISCSI2 -ip $Server.ISCSI2 -SubnetMask $Server.iscsisubmask -Confirm:$false

    # Sets VLAN on ISCSI vmkernal port if tagged

    $ISCSI1VLAN = get-virtualportgroup -name iscsi1
    $ISCSI2VLAN = get-virtualportgroup -name iscsi2
        if($Server.iSCSIVLAN1 -eq "")
        {
        Write-Host "ISCSI 1 VLAN IS UNTAGGED!!!!" -ForegroundColor Green
        }
        else
        {
        set-virtualportgroup -virtualportgroup $ISCSI1VLAN -vlanid $Server.iscsivlan1
        }
        if($Server.iSCSIVLAN2 -eq "")
        {
        Write-Host "ISCSI 2 VLAN IS UNTAGGED!!!!" -ForegroundColor Green
        }
        else
        {
        set-virtualportgroup -virtualportgroup $ISCSI1VLAN -vlanid $Server.iscsivlan2
        }

    }
    else
    {
    #Create Single VSWitch with Multiple VMkernal ISCSI adapters on same Subnet

    New-VirtualSwitch -VMHost $Host1 -Name "ISCSI" -Mtu 9000
    $iVSwitch = get-virtualswitch -vmhost $Host1 -Name "ISCSI"

    New-VMHostNetworkAdapter -VMHost $Host1 -PortGroup iscsi1 -VirtualSwitch $iVSwitch -MTU 9000
    New-VMHostNetworkAdapter -VMHost $Host1 -PortGroup iscsi2 -VirtualSwitch $iVSwitch -MTU 9000

    # Adds Physical Adapters to ISCSI vSwitches.

    $PHYSISCSI1 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyISCSINIC1
    $iVSwitch | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYSISCSI1 -Confirm:$false

    $PHYSISCSI2 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyISCSINIC2
    $iVSwitch | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYSISCSI2 -Confirm:$false

    # Sets IP Address of ISCSI VMKERNAL PORTS

    $ISCSI1 = get-vmhostnetworkadapter | where { $_.portgroupname -eq "iscsi1" }
    set-vmhostnetworkadapter -virtualnic $ISCSI1 -ip $Server.ISCSI1 -SubnetMask $Server.iscsisubmask -Confirm:$false

    $ISCSI2 = get-vmhostnetworkadapter | where { $_.portgroupname -eq "iscsi2" }
    set-vmhostnetworkadapter -virtualnic $ISCSI2 -ip $Server.ISCSI2 -SubnetMask $Server.iscsisubmask -Confirm:$false

    # Sets VLAN on ISCSI vmkernal port if tagged

    $ISCSI1VLAN = get-virtualportgroup -name iscsi1
    $ISCSI2VLAN = get-virtualportgroup -name iscsi2
        if($Server.iSCSIVLAN1 -eq "")
        {
        Write-Host "ISCSI 1 VLAN IS UNTAGGED!!!!" -ForegroundColor Green
        }
        else
        {
        set-virtualportgroup -virtualportgroup $ISCSI1VLAN -vlanid $Server.iscsivlan1
        }
        if($Server.iSCSIVLAN2 -eq "")
        {
        Write-Host "ISCSI 2 VLAN IS UNTAGGED!!!!" -ForegroundColor Green
        }
        else
        {
        set-virtualportgroup -virtualportgroup $ISCSI1VLAN -vlanid $Server.iscsivlan2
        }

    #Sets ISCSI Teaming Policies
    $ISCSI1TEAMPOLICY = get-virtualportgroup | where { $_.Name -eq "iscsi1" } | Get-NicTeamingPolicy
    Set-NicTeamingPolicy -VirtualPortGroupPolicy $ISCSI1TEAMPOLICY -InheritFailoverOrder $false
    Set-NicTeamingPolicy -VirtualPortGroupPolicy $ISCSI1TEAMPOLICY -MakeNicActive $Server.PhyISCSINIC1
    Set-NicTeamingPolicy -VirtualPortGroupPolicy $ISCSI1TEAMPOLICY -MakeNicUnused $Server.PhyISCSINIC2

    $ISCSI2TEAMPOLICY = get-virtualportgroup | where { $_.Name -eq "iscsi2" } | Get-NicTeamingPolicy
    Set-NicTeamingPolicy -VirtualPortGroupPolicy $ISCSI2TEAMPOLICY -InheritFailoverOrder $false
    Set-NicTeamingPolicy -VirtualPortGroupPolicy $ISCSI2TEAMPOLICY -MakeNicActive $Server.PhyISCSINIC2
    Set-NicTeamingPolicy -VirtualPortGroupPolicy $ISCSI2TEAMPOLICY -MakeNicUnused $Server.PhyISCSINIC1

    }
    


#Enables iSCSI Software Initiator

get-vmhoststorage | Set-Vmhoststorage -SoftwareISCSIenabled $true

start-sleep -s 5

#Add Network Adapter and Targets to iSCSI Initiator and use port binding if using a single subnet. 

if($Server.MultiSubNetISCSI -eq "Yes")
{
write-host "!!!VMkernal ports used for ISCSI are in different broadcast domains/subnets. Will Not Use Port Binding!!!" -ForegroundColor Green
}
else
{
##$esxcli = get-esxcli
$iscsisoftware = get-vmhosthba -type iscsi | where { $_.status -eq "online"}
$vmk1number = 'vmk1'
$vmk2number = 'vmk2'
$esxcli.iscsi.networkportal.add($iscsisoftware,$true,$vmk1number)
$esxcli.iscsi.networkportal.add($iscsisoftware,$true,$vmk2number)
}


#Add IP Addresses of ISCSI Targets

$iscsisoftware = get-vmhosthba -type iscsi | where { $_.status -eq "online"}

$iscsisoftware | New-IScsiHbaTarget -Address $Server.Iscsitarget1
$iscsisoftware | New-IScsiHbaTarget -Address $Server.Iscsitarget2

# Create VM Network Switch
New-VirtualSwitch -VMHost $Host1 -Name "Virtual Machine Network"

# Add VM Networks Switch Port Group

$VMNETSWITCH = get-virtualswitch -vmhost $Host1 -Name "Virtual Machine Network"
New-VirtualPortGroup -Name $Server.VMNET1NAME -VLanId $SERVER.VMNET1VLAN -VirtualSwitch $VMNETSWITCH
New-VirtualPortGroup -Name $Server.VMNET2NAME -VLanId $SERVER.VMNET2VLAN -VirtualSwitch $VMNETSWITCH
New-VirtualPortGroup -Name $Server.VMNET3NAME -VLanId $SERVER.VMNET3VLAN -VirtualSwitch $VMNETSWITCH
New-VirtualPortGroup -Name $Server.VMNET4NAME -VLanId $SERVER.VMNET4VLAN -VirtualSwitch $VMNETSWITCH

#Add Physical Network Adapters to Default Management Network Switch

$DEFAULTMANAGEMENTSWITCH = get-virtualswitch -vmhost $Host1 -Name "vSwitch0"
$PHYMANNIC2 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyMANNIC2
$DEFAULTMANAGEMENTSWITCH | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYMANNIC2 -Confirm:$false


#Set Teaming Policy on Defualt Manaement Switch

$DefaultManTeam = get-virtualportgroup | where { $_.Name -eq "Management Network" } | Get-NicTeamingPolicy
Set-NicTeamingPolicy -VirtualPortGroupPolicy $DefaultManTeam -InheritFailoverOrder $false
Set-NicTeamingPolicy -VirtualPortGroupPolicy $DefaultManTeam -MakeNicStandby $Server.PhyMANNIC2

#Add Physical Network Adapters to VM Network Switch

$PHYLANNIC1 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyLANNIC1
$VMNETSWITCH | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYLANNIC1 -Confirm:$false
$PHYLANNIC2 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyLANNIC2
$VMNETSWITCH | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYLANNIC2 -Confirm:$false
$PHYLANNIC3 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyLANNIC3
$VMNETSWITCH | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYLANNIC3 -Confirm:$false
$PHYLANNIC4 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyLANNIC4
$VMNETSWITCH | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYLANNIC4 -Confirm:$false


#Add Physical Network Adapters to VM Network Switch

New-VirtualSwitch -VMHost $Host1 -Name "VMotion" -Mtu 9000

# Add VMotion Network Swith Port Group

$VMotionSWITCH = get-virtualswitch -vmhost $Host1 -Name "VMotion"
New-VMHostNetworkAdapter -VMHost $Host1 -PortGroup "VMotion" -VirtualSwitch $VMotionSWITCH -VMotionEnabled $true -MTU 9000

# Add Physical Network Adapters to VMotion Network Swtich will need to edit !!!!

$PHYVMONIC1 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyVMONIC1
$VMotionSWITCH | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYVMONIC1 -Confirm:$false
$PHYVMONIC2 = $Host1 | get-vmhostnetworkadapter -Physical -name $Server.PhyVMONIC2
$VMotionSWITCH | Add-VirtualSwitchPhysicalNetworkAdapter -VMHostPhysicalNic $PHYVMONIC2 -Confirm:$false

# Sets IP Address of VMotion Port Group
$Vmotion = get-vmhostnetworkadapter | where { $_.portgroupname -eq "VMotion" }
set-vmhostnetworkadapter -virtualnic $Vmotion -ip $Server.VMotionIP -SubnetMask $Server.VmotionMask -Confirm:$false

# Set NIC Teaming Policy for VMotion
$VMOTEAMPOLICY = get-virtualportgroup | where { $_.Name -eq "VMotion" } | Get-NicTeamingPolicy
Set-NicTeamingPolicy -VirtualPortGroupPolicy $VMOTEAMPOLICY -InheritFailoverOrder $false
Set-NicTeamingPolicy -VirtualPortGroupPolicy $VMOTEAMPOLICY -MakeNicActive $Server.PhyVMONIC1
Set-NicTeamingPolicy -VirtualPortGroupPolicy $VMOTEAMPOLICY -MakeNicStandby $Server.PhyVMONIC2

# Set VMotion VLAN
$VMOVLAN = get-virtualportgroup -name VMotion
set-virtualportgroup -virtualportgroup $VMOVLAN -vlanid $Server.VmotionVLAN

Disconnect-viserver -Server * -Force -Confirm:$false

$S++
Write-Progress -Activity "Configuring ESXI Hosts" -status "Configured: $S of $($Servers.Count)" -PercentComplete (($S / $Servers.Count) * 100)

    }


Write-Host "!!!Host Configurations Complete!!!" -ForegroundColor Green

Stop-Transcript




